public class phase3
{
	private static val parEngine:Engine = new ParallelEngine(4);
	private static val seqEngine:Engine = new SequentialEngine();

	public static def run(test:String,A:Matrix,B:Matrix)
	{
		val msg:String = "Running "+test+" functional test";
		val numDots:Int = 38 - msg.length();
		Console.OUT.print(msg);
		for(var i:Int=0;i<numDots;i++) Console.OUT.print(".");
		var parResult:Matrix = new Matrix(0);
		var seqResult:Matrix = new Matrix(1);
		if(test.equals("plus")) {
			parResult = parEngine.plus(A,B);			
			seqResult = seqEngine.plus(A,B);
		}
		if(test.equals("minus")) {
			parResult = parEngine.minus(A,B);
			seqResult = seqEngine.minus(A,B);
		}
		if(test.equals("mtimes")) {
			parResult = parEngine.mtimes(A,B);
			seqResult = seqEngine.mtimes(A,B);
		}
		if(test.equals("times")) {
			parResult = parEngine.times(A,B);
			seqResult = seqEngine.times(A,B);
		}
		if(test.equals("invert")) {
			parResult = parEngine.invert(A);
			seqResult = seqEngine.invert(A);
		}
		if(test.equals("mrdivide")) {
			parResult = parEngine.mrdivide(A,B);
			seqResult = seqEngine.mrdivide(A,B);
		}
		if(test.equals("rdivide")) {
			parResult = parEngine.rdivide(A,B);
			seqResult = seqEngine.rdivide(A,B);
		}
		if(test.equals("mldivide")) {
			parResult = parEngine.mldivide(A,B);
			seqResult = seqEngine.mldivide(A,B);
		}
		if(test.equals("ldivide")) {
			parResult = parEngine.ldivide(A,B);
			seqResult = seqEngine.ldivide(A,B);
		}
		if(test.equals("mpower")) {
			parResult = parEngine.mpower(A,B);
			seqResult = seqEngine.mpower(A,B);
		}
		if(test.equals("power")) {
			parResult = parEngine.power(A,B);
			seqResult = seqEngine.power(A,B);
		}
		if(seqResult.equals(parResult)) { 
			Console.OUT.println(" PASSED.");
		} else { 
			Console.OUT.println(" FAILED");
			Console.OUT.println("Sequential");
			Console.OUT.println(seqResult);
			Console.OUT.println("Parallel");
			Console.OUT.println(parResult);
		}
	}

	public static def main(argv:Array[String])
	{
		val A:Matrix = new Matrix("{20,20}");
		val B:Matrix = new Matrix("{20,20}");
		val x:Matrix = new Matrix(3);
		val y:Matrix = new Matrix(10);
		val C:Matrix = new Matrix("{2,2}");
		C(0,0) = 1;
		C(0,1) = 6;
		C(1,0) = 3;
		C(1,1) = 9;	
		val D:Matrix = new Matrix("{3,3}");
		
		run("plus",A,B);
		run("plus",A,y);
		run("plus",x,B);
		run("minus",A,B);
		run("minus",A,y);
		run("minus",x,B);
		run("mtimes",A,B);
		run("times",A,B);
		run("times",A,y);
		run("times",x,B);
		run("invert",A,x);
		run("mrdivide",A,B);
		run("mldivide",A,B);
		run("mpower",C,x);
		run("power",A,x);
		run("power",x,A);	
	}
}
